#include "stdafx.h"
#include <afxpriv.h>	// WM_SOCKET_NOTIFY
#include "ASocket1153.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#pragma pack(push,1)

// ALX1153::ASocketH
namespace ALX1153
{
	namespace ASocketH
	{

		enum ee_SendRecvLengths
		{
			//   
			e_net_MaxOnceSendLen		=	0x1000		,//  ,     =
															//[1 ... 0xFFFE-sizeof(CHdr88)] ( CHdr88::m_wPsize)
															//       
															//ASocketClient::Us_ReceiveInmcoming88Data().

			e_net_MaxOnceRecvLen		=	e_net_MaxOnceSendLen,
		};

	};//ASocketH
};//ALX1153


// CTimeOut
namespace ALX1153
{
	namespace ASocketH
	{
		//  
		//  - 0xffffffff  49  17  2 .
		CTimeOut::CTimeOut(DWORD dwdTO,bool bStartAtNow)//=false
		{
			m_dwdBegin=0;
			m_dwdLast=0;
			m_bWasStarted=false;
			m_dwdTO=dwdTO;

			if(bStartAtNow)
			{
				Start();
			}
		}

		void CTimeOut::Start()
		{
			m_dwdBegin=::GetTickCount();
			m_dwdLast=m_dwdBegin+m_dwdTO;
			m_bWasStarted=true;
		}

		void CTimeOut::Restart()
		{
			Start();
		}

		void CTimeOut::Stop()
		{
			m_dwdBegin=m_dwdLast=0;
		}

		int CTimeOut::GetPercent_0_100()
		{
			int percent=100-100*(m_dwdLast-::GetTickCount())/m_dwdTO;
			if(percent<0)percent=0;
			if(percent>100)percent=100;
			return percent;
		}

		bool CTimeOut::GotEnd(bool bFalseOnceIfWasGotEndWithoutAskingBetweenStartAndStop)//=false
		{
			if(bFalseOnceIfWasGotEndWithoutAskingBetweenStartAndStop)
			{
				if(m_bWasStarted)
				{
					m_bWasStarted=false;
					return false;
				}
			}

			DWORD dwdCurrent=::GetTickCount();
			if(m_dwdBegin==m_dwdLast)
			{
				return true;
			}
			else
			if(m_dwdBegin<m_dwdLast)
			{
				// c B c L c
				if(dwdCurrent>=m_dwdLast || dwdCurrent<m_dwdBegin)
				{
					// [c)B...L[c]
					Stop();
					return true;
				}
				else
				{
					// ...B(c]L...
					return false;
				}
			}
			else
			{
				// c L c B c
				if(dwdCurrent<m_dwdBegin && dwdCurrent>=m_dwdLast)
				{
					// ...L[c)B...
					Stop();
					return true;
				}
				else
				{
					// [c)L...B[c]
					return false;
				}
			}

			//   
			Stop();
			return true;
		}
	};//ASocketH
};//ALX1153

//class ASocketParent
namespace ALX1153
{
	ASocketParent::ASocketParent()
		:m_DataWereSentTO(e_FlashTO)
		,m_DataWereRecvTO(e_FlashTO)
		
	{
		m_LastSetEventMask=0;
	}

	//
	ASocketParent::~ASocketParent()
	{
		if(m_hSocket!=INVALID_SOCKET)
		{
			AsyncSelect(0);
			Close();
		}
	}
};





//class ASocketClient:public ASocketParent
namespace ALX1153
{
	//    
	void ASocketClient::__SelectEvents_client_JustRefresh()
	{
		__SelectEvents_client(0,false,true);
	}

	//    
	void ASocketClient::__SelectEvents_client(int B_On,bool bOnConnectAlways,bool bJustRefresh)//=false,=false
	{
		if(m_hSocket==INVALID_SOCKET)return;

		if(bJustRefresh)
		{
			ASocketParent::AsyncSelect(m_LastSetEventMask);
		}
		else
		{
			if(!B_On)
			{
				m_LastSetEventMask=(FD_CLOSE|(bOnConnectAlways?FD_CONNECT:0));
			}
			else
			{
				m_LastSetEventMask=(FD_READ|FD_WRITE|FD_OOB|FD_CONNECT|FD_CLOSE);
			}

			//    ASocketClient::OnReceive
			ASocketParent::AsyncSelect(m_LastSetEventMask);
		}

	}


	bool ASocketClient::Us_WaitOneConnectEvent(DWORD dwdTO,DWORD dwdTimeStep,bool (*WaitCancelCallBack)(int percent,void* pData),void* pData)
	{
		if(!__Polling(FD_CONNECT,dwdTO,dwdTimeStep,WaitCancelCallBack,pData))
		{
			return false;
		}

		return Us_IsClient__Connected();
	}

	bool ASocketClient::Us_WaitOneReceiveEvent(DWORD dwdTO,DWORD dwdTimeStep,bool (*WaitCancelCallBack)(int percent,void* pData),void* pData)
	{
		return __Polling(FD_READ,dwdTO,dwdTimeStep,WaitCancelCallBack,pData);
	}

	void ASocketClient::Us_WaitAndRemoveSendEvents()
	{
		__Polling(FD_WRITE,0,0,0,0);
	}


	bool ASocketClient::__Polling(long Event,DWORD dwdTO,DWORD dwdTimeStep,bool (*WaitCancelCallBack)(int percent,void* pData),void* pData)
	{
		MSG m;
		BOOL bRet=0;

		if(Event==FD_WRITE)
		{
			//   FD_WRITE
			//  Event
			while(1)
			{
				::memset(&m,0,sizeof(m));
				bRet=::PeekMessage(&m,0,WM_SOCKET_NOTIFY,WM_SOCKET_NOTIFY,PM_NOREMOVE);
				if(bRet==-1)break;

				if(bRet && Event==(long)m.lParam && m_hSocket==(SOCKET) m.wParam)
				{ 
					::memset(&m,0,sizeof(m));
					bRet=::PeekMessage(&m,0,WM_SOCKET_NOTIFY,WM_SOCKET_NOTIFY,PM_REMOVE);
					if(bRet==-1)break;
					continue;
				}

				break;
			}
		}
		else
		{
			//  Event
			ASocketH::CTimeOut TO(dwdTO,true);
			while(1)
			{
				::memset(&m,0,sizeof(m));
				bRet=::PeekMessage(&m,0,WM_SOCKET_NOTIFY,WM_SOCKET_NOTIFY,PM_NOREMOVE);
				if(bRet==-1)break;

				if(bRet && Event==(long)m.lParam && m_hSocket==(SOCKET) m.wParam)
				{ 
					::memset(&m,0,sizeof(m));
					bRet=::PeekMessage(&m,0,WM_SOCKET_NOTIFY,WM_SOCKET_NOTIFY,PM_REMOVE);
					if(bRet==-1)break;
					if(bRet==0)break;//     -     

					// 
					::TranslateMessage(&m);
					::DispatchMessage(&m);
					return true;
				}

				Sleep(dwdTimeStep);

				if(TO.GotEnd())break;
				if(WaitCancelCallBack && WaitCancelCallBack(TO.GetPercent_0_100(),pData))break;
			}
		}



		return false;
	}


	bool ASocketClient::Us_CalcMonitorsRect(CDC& destDC,const CRect& LayoutRect)const
	{

		enum// ee_colorcode
		{
			e_Off=0,	//  (,  (92,92,92) )
			e_DarkH,	//   (, -(0,100,0) )
			e_LightH,	//  (, - (0,255,0) )
			e_DarkT,	//   (, -(0,100,0) )
			e_LightT,	//  (, - (0,255,0) )
			e_ColorsCounter,// 
		};

		enum
		{
			e_leftop_border=1,
			e_rigbot_border=0,
		};

		static DWORD default_colorArr[e_ColorsCounter]=
		{
			RGB(92,92,92)	,//	e_Off=0
			RGB(20,150,20)	,//	e_DarkH
			RGB(50,255,50)	,//	e_LightH
			RGB(0,100,0)	,//	e_DarkT
			RGB(40,230,40)	,//	e_LightT
		};

		//  
		struct placement
		{
			CRect rect;
			DWORD dwdRGB;

			placement():rect(0,0,0,0),dwdRGB(0)
			{
			}
		}
		pmH,pmT;


		const DWORD* colorArr=0;
		DWORD dwdLenOfColorArray=0;

		colorArr=default_colorArr;
		dwdLenOfColorArray=sizeof(default_colorArr)/sizeof(*default_colorArr);

		pmH=placement();
		pmT=placement();

		if(this==0 || m_hSocket==INVALID_SOCKET || dwdLenOfColorArray!=e_ColorsCounter)
		{
			return false;
		}

		long H=LayoutRect.Height()-e_leftop_border-e_rigbot_border;
		long W=LayoutRect.Width() -e_leftop_border-e_rigbot_border;
		if(H<=0 || W<=0)return false;

		long H1=H*70/100;//70%
		long W1=W*70/100;//70%

		if(H1<=0 || W1<=0)return false;

		pmH.rect.left	=LayoutRect.left+e_leftop_border;
		pmH.rect.top	=LayoutRect.top+e_leftop_border;
		pmH.rect.right	=pmH.rect.left+W1-1;
		pmH.rect.bottom	=pmH.rect.top+H1-1;

		pmT.rect.right	=LayoutRect.right-e_rigbot_border;
		pmT.rect.bottom	=LayoutRect.bottom-e_rigbot_border;
		pmT.rect.left	=pmT.rect.right-W1+1;
		pmT.rect.top	=pmT.rect.bottom-H1+1;

		ASocketClient* pCL=(ASocketClient*)this;

		//   
		if(!pCL->m_DataWereSentTO.GotEnd(true))
		{
			pmH.dwdRGB=colorArr[e_LightH];
		}
		else
		{
			pmH.dwdRGB=colorArr[e_DarkH];
		}

		//   
		if(!pCL->m_DataWereRecvTO.GotEnd(true))
		{
			pmT.dwdRGB=colorArr[e_LightT];
		}
		else
		{
			pmT.dwdRGB=colorArr[e_DarkT];
		}

		destDC.FillSolidRect(pmT.rect,pmT.dwdRGB);
		destDC.FillSolidRect(pmH.rect,pmH.dwdRGB);

		return true;
	}

	bool ASocketClient::Us_IsClient__Connected()
	{
		return m_bIsConnected;
	}

	bool ASocketClient::Us_IsClient__BadDisconnectedAfterLastConnect()const
	{
		return m_bBadDisconnect;
	}

	bool ASocketClient::Us_IsWorking_checkJustHandle()const
	{
		return (m_hSocket!=INVALID_SOCKET);
	}

	bool ASocketClient::Us_StartWorkingClient(const char* pchAddress,WORD wServerPort,bool bPauseEventsBeforeWorking)
	{
		Us_StopWorking();
		if(m_hSocket!=INVALID_SOCKET)return false;

		if(!Create(0,SOCK_STREAM,0))return false;

		//    
		if(pchAddress)
		{
			//    OnConnect
			//   ,      m_bIsConnected
			__SelectEvents_client(0,true);

			ASocketParent::Connect(pchAddress,(wServerPort));
		}
		else
		{
			return false;
		}
		DWORD dwdConnRes=this->GetLastError();

		if(dwdConnRes==0 || dwdConnRes==WSAEWOULDBLOCK)
		{
			//  0   WSAEWOULDBLOCK
			//  ,  OnConnect()
			m_bBadDisconnect=false;
		}
		else
		{
			Us_StopWorking();
			return false;
		}


		if(bPauseEventsBeforeWorking)
		{
			__SelectEvents_client(0);
		}
		else
		{
			__SelectEvents_client(1);
		}
			
		return true;
	}

	void ASocketClient::Us_StopWorking()const
	{
		if(m_hSocket!=INVALID_SOCKET)
		{
			((ASocketClient*)this)->__SelectEvents_client(0);
			((ASocketClient*)this)->OnClose(0);
		}
	}

	int ASocketClient::Us_GetMaxOneSendLen()
	{
		return ASocketH::e_net_MaxOnceSendLen;
	}

	int ASocketClient::Us_Send(const void* lpBuf, int nBufLen, int nFlags)const
	{
		return ((ASocketClient*)this)->Send(lpBuf,nBufLen,nFlags);
	}


	int ASocketClient::Us_Receive(void* lpBuf,const int nBufLen, int nFlags)
	{
		return Receive(lpBuf,nBufLen,nFlags);
	}

	bool ASocketClient::Us_GetIsEventOn_OnReceive()
	{
		return (m_LastSetEventMask&FD_READ) ? true : false;
	}

	void ASocketClient::Us_PauseEvents()
	{
		__SelectEvents_client(0);
	}

	void ASocketClient::Us_StartEvents()
	{
		__SelectEvents_client(1);
	}

	bool ASocketClient::Us_GetPeerIP(DWORD& dwdIP,WORD& wPort)const 
	{
		dwdIP=0;
		CString csIP;
		if(!Us_GetPeerIP(csIP,wPort))return false;
		dwdIP=inet_addr(csIP);
		return true;
	}

	bool ASocketClient::Us_GetPeerIP(CString& csIP,WORD& wPort)const
	{
		csIP="";
		wPort=0;
		UINT port=0;
		if(!((ASocketParent*)this)->GetPeerName(csIP,port))return false;
		wPort=(WORD)port;
		return true;
	}

	int ASocketClient::Send(const void* lpBuf, int nBufLen, int nFlags)
	{
		const DWORD dwdBeginTicks=::GetTickCount();

		if(!lpBuf || !nBufLen)
		{
			return 0;
		}
		if(!Us_IsWorking_checkJustHandle())return 0;

		int nLenSent=0;

		if(nBufLen<=Us_GetMaxOneSendLen())
		{
			for(;;)
			{
				nLenSent=ASocketParent::Send(lpBuf,nBufLen,0);

				if(nLenSent==SOCKET_ERROR && this->GetLastError()==WSAEWOULDBLOCK)
				{
					if(VF_FeedBackFromSend_RetTrueIfNeedCancel(::GetTickCount()-dwdBeginTicks))break;
					continue;
				}

				m_Statistics.m_BytesSent_____all+=nLenSent;

				m_DataWereSentTO.Restart();

				break;
			}
		}
		return nLenSent;
	}
	int ASocketClient::Receive(void* lpBuf, int nBufLen, int nFlags)
	{
		
		if(!lpBuf || !nBufLen)return 0;//true
		if(!Us_IsWorking_checkJustHandle())return 0;
		int nLenGot=0;

		nLenGot=ASocketParent::Receive(lpBuf,nBufLen,0);

		if(nLenGot==SOCKET_ERROR)
		{
			nLenGot=0;
		}
		else
		{
			if(nLenGot)
			{

				m_Statistics.m_BytesReceived_all+=nLenGot;

				m_DataWereRecvTO.Restart();
			}
		}

		return nLenGot;
	}

	void ASocketClient::OnReceive(int nErrorCode)
	{
		//,     )

		//  
		VF_OnReceive();

		//     FD_READ (OnReceive)
		//( -  ...)
		// 
		__SelectEvents_client_JustRefresh();
	}

	void ASocketClient::OnSend(int nErrorCode)
	{
	}

	void ASocketClient::OnOutOfBandData(int nErrorCode)
	{
	}

	void ASocketClient::OnConnect(int nErrorCode)
	{
		if(nErrorCode==0)
		{
			//   ,    
			//    
			m_bIsConnected=true;
			m_bBadDisconnect=false;
			VF_OnConnected();
		}
		else
		{
			Us_StopWorking();
		}
	}

	void ASocketClient::OnClose(int nErrorCode)
	{
		m_bIsConnected=false;
		m_bBadDisconnect=(nErrorCode!=0);

		//  
		ASocketParent::Close();
		VF_OnAfterClose();
	}

	//
	ASocketClient::ASocketClient()
	{
		m_bIsConnected=false;
		m_bBadDisconnect=false;
	}

	//
	ASocketClient::~ASocketClient()
	{
	}
};

#pragma pack(pop)
